#Component Placer
#By TAK2HATA
#First Released:Apr07,2013.
#Update:Ver1.0:Apr15,2013.
#Update:Ver1.2beta:Apr23,2013.
#site: http://sketchup-onigiri.jimdo.com/
###日本語
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
##免責事項
##このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
#
require 'sketchup.rb'
#begin
#	require 'nkf';$nkfexist = true
#rescue LoadError
#	$nkfexist = false
#end
module TSTComponentPlacer
    class CompPlacer
		def nkfconv(txt)
			return txt
			#if txt
			#	return NKF.nkf('-Wsx', txt)
			#else
			#	return txt
			#end
		end
		def initialize( )
			#p "ini"
			create_cp_bounds_all
			show_webdialog
        	@dlist = []
        	@dfname = ""
			@rot = 0.0
			@fixz = ""
			@dx = 0.0
			@dy = 0.0
			@dz = 0.0
			@tbb_pts = []
			@tbb_lines = []
			@dfolder = "HOME"
		end
        def reset(view)
			#p "reset"
        	@instance = nil
            @drawn = false
			
            @ip.clear
			@message = "Place #{@dfname}First point"
			show_status_text
			create_instance
			if( view )
				view.tooltip = nil
				view.invalidate if @drawn
			end
			#dialog()
			Sketchup::set_status_text "", SB_VCB_VALUE
        end

        def resume(view)
			#p "resume"
            if @state == 0
				@message = "#{@dfname} Place"
				show_status_text
            end
        end
		
        def activate
			#p "acti"
            @ip  = Sketchup::InputPoint.new
            @ip1 = Sketchup::InputPoint.new
            #Sketchup.active_model.active_view.lock_inference
            self.reset(nil)
        end

        def deactivate(view)
			#p "deact"
            view.invalidate if @drawn
			abort()
        end

        def onCancel(flag, view)
			#p "cancel"
            # Clean view and exit the tool
            view.invalidate if @drawn
			abort()
        end
		def abort()
			#p "abort"
			Sketchup.active_model.abort_operation
			$tst_cp_tool_wdlg.close if $tst_cp_tool_wdlg
			clear_dialog
		end
        def onReturn(view)
			#p "return"
		end
		

        def onRButtonDown(flags, x, y, view)

        end

        def onUserText(text, view)
        end #onUserText
		
        def onMouseMove(flags, x, y, view)
        	#@instance.hidden = true if @instance
            #if( @state == 0 )
			show_status_text
			# Getting the first end
			if not @instance or not @instance.valid?
				create_instance()
			end
			@instance.hidden = true if @instance and @instance.valid?
			@ip.pick view, x, y
			if( @ip != @ip1 )
			#if @ip.valid?
				# if the point has changed from the last one we got
				#@drawn == true
				@ip1.copy! @ip
				moveInstance
				
				@drawn = true
				# set the tooltip that should be displayed to this point
				#view.tooltip = @ip1.tooltip
				# or @ip1.display? )
				#if @ip1.display?
				#if @instance and @instance.transformation != @t_pos
					#view.invalidate
				#end
				#end
			end
			@instance.hidden = false if @instance and @instance.valid?
			if @fixz == ""
				zval = @ip1.position.z
			else
				zval = @fixz.to_l
			end
			view.tooltip = @ip1.tooltip + "\nZ=#{zval}"
            #end
            #@instance.hidden = false if @instance
        end

        def onLButtonDown(flags, x, y, view)
			if( @ip1.valid? )
				if @instance and @instance.valid?
					if $tst_cp_tool_wdlg
						tag = []
						(0..2).each{|i|
							tag =$tst_cp_tool_wdlg.get_element_value("CP_TAG#{i+1}")
							@instance.set_attribute("ComponentsPlacer","TAG#{i+1}",tag )
						}
					end
					if @bb_grp and @bb_grp.valid?
						@bb_grp.hidden = true
						#Sketchup.active_model.entities.erase_entities( @bb_grp )
					end
					#@bb_grp = nil
					@bb_grp_ents = nil
					Sketchup.active_model.commit_operation
					#@instance2 = @instance
					Sketchup.active_model.start_operation "Draw Bounding LINES",true,true,false if Sketchup.version.to_f >= 7.0
					create_cp_bounds( @instance )
					Sketchup.active_model.commit_operation if Sketchup.version.to_f >= 7.0
				end
				reset(nil)
			end
            view.invalidate
        end
        
        # Draw temp line between ends of partition axis
        def draw_temp_line(pt1, pt2, view)
            #view.drawing_color = "red"
            view.set_color_from_line(pt1, pt2)
            #view.line_stipple="-.-"
            if view.inference_locked?
                view.line_width=2
            end
            @bbp = [pt1, pt2]
            view.draw_line(pt1, pt2)
        end

        def onKeyDown(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY )
                if( view.inference_locked? )
                    view.lock_inference
                else
                    view.lock_inference @ip1
                end
                view.invalidate
            end
        end
        def onKeyUp(key, repeat, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY && view.inference_locked? )
                view.lock_inference
            end
            #onSetCursor # trigger change of cursore on screen
        end

        def draw(view)

            # Show input points when valid
            
			#if( @ip1.valid? )
                #if( @ip1.display? )
			#@instance.hidden = false if @instance and @instance.hidden?
			#if @drawn == true
				
				#@instance.transformation = @t_pos if @instance and @t_pos and @instance.transformation != @t_pos

				view.draw_points( @bb_pts , 10 , 2 , "green" ) if @bb_pts and @bb_pts != []

			#end
                    #@ip1.draw(view)
                #end  
            #end
			view.draw_points( @tbb_pts , 10 , 2 , "green" ) if @tbb_pts != []
			view.draw_lines( @tbb_lines.flatten ) if @tbb_lines != []
        end

		def getMenu(menu)
			menu.add_item("Rotation + 90deg") {
				 add_rotation(90)
			}
			menu.add_item("Rotation - 90deg") {
				 add_rotation(-90)
			}
			menu.add_item("Fix Z to 0.0"){
				@fixz = "0.0"
				$tst_cp_tool_wdlg.execute_script( "document.getElementById('CP_FIXZ').value = '#{@fixz}'" )
			}
			menu.add_item("Fix Z to here"){
				@fixz = @ip1.position.z.to_s
				$tst_cp_tool_wdlg.execute_script( "document.getElementById('CP_FIXZ').value = '#{@fixz}'" )
			}
			menu.add_item("Fix Z to free"){
				@fixz = ""
				$tst_cp_tool_wdlg.execute_script( "document.getElementById('CP_FIXZ').value = '#{@fixz}'" )
			}
		end
		def show_status_text
			Sketchup::set_status_text @message
		end
		def create_instance
			model = Sketchup.active_model
			dfs = model.definitions
			operation_name = "Component Placer"
			#create_cp_bounds( @instance2 ) if @instance2 and @instance2.valid?
			#@instance2 = nil
			
			if @dfolder == "HOME" and @dfname and @dfname != ""
				df = dfs[ @dfname ]
				if df
					Sketchup.active_model.start_operation operation_name
					@instance = model.active_entities.add_instance df , Geom::Transformation.new
					@instance.hidden = true
					calc_dxyz()
				end
			else
				df = dfs[ @dfname ] if @dfname and @dfname != ""
				if not df and @dfilename and @dfilename != ""
					df = dfs.load( File.join( @dfolder , @dfilename ) )
					if df
						Sketchup.active_model.start_operation operation_name
						@instance = model.active_entities.add_instance df , Geom::Transformation.new
						@instance.hidden = true
						calc_dxyz()
					end
				end
			end
			
		end

        def moveInstance()
			if @instance and @instance.valid?
				zval = 0.0
				if @fixz == ""
					zval = @ip1.position.z
				else
					zval = @fixz.to_l
				end
				@t_pos = Geom::Transformation.translation( Geom::Vector3d.new( - @dx , - @dy , - @dz  ) )
				@t_pos = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(0,0,1) , @rot.degrees ) * @t_pos if @rot
				@t_pos = Geom::Transformation.translation( Geom::Vector3d.new( @ip1.position.x , @ip1.position.y , zval ) ) * @t_pos
				if @instance and @instance.valid? and @t_pos and @instance.transformation != @t_pos
					@instance.transformation = @t_pos
					create_cp_bounds( @instance , true )
					@instance.hidden = false if @instance.hidden?
				end
			end
        end
		
		def clear_dialog()
			if $tst_cp_tool_wdlg
				$tst_cp_tool_wdlg = nil
				#Sketchup.active_model.entities.erase_entities( @instance ) if @instance
				Sketchup.active_model.entities.erase_entities( @bb_grp ) if @bb_grp and @bb_grp.valid?
				@bb_grp = nil
				@bb_grp_ents = nil
				Sketchup.active_model.select_tool nil
			end
		end
		def calc_dxyz()
			bbs = @instance.definition.bounds
			@dx = 0.0
			@dy = 0.0
			@dz = 0.0
			if @alignX != ""
				if @alignX == "MIN"
					@dx = bbs.min.x
				elsif @alignX == "MAX"
					@dx = bbs.max.x
				elsif @alignX == "MID"
					@dx = bbs.center.x
				end
				if @alignY == "MIN"
					@dy = bbs.min.y
				elsif @alignY == "MAX"
					@dy = bbs.max.y
				elsif @alignY == "MID"
					@dy = bbs.center.y
				end
				if @alignZ == "MIN"
					@dz = bbs.min.z
				elsif @alignZ == "MAX"
					@dz = bbs.max.z
				elsif @alignZ == "MID"
					@dz = bbs.center.z
				end
			end
		end
		def add_rotation( dg )
			@rot = @rot + dg
			@rot = @rot - 360 if @rot >= 360
			@rot = @rot + 360 if @rot <= -360
			$tst_cp_tool_wdlg.execute_script( "document.getElementById('CP_ROTATE').value = '#{@rot}'" )
		end
		def show_webdialog
			if $tst_cp_tool_wdlg
				UI.messagebox "BST TOOL BOX is already running"
				return
			end
			cphtml = get_htmlcode() #readtextfile( wdlgpath )
			#cphtml = langconv_html(cphtml)
			prfkeys = { 
				:dialog_title => langconv('Components Placer'), 
				:scrollable => true, 
				:preferences_key => 'ComponentsPlacer', 
				:height => 565, 
				:width => 325, 
				:left => 150, 
				:top => 150, 
				:resizable => true, 
				:mac_only_use_nswindow => true
			} 
			$tst_cp_tool_wdlg = UI::WebDialog.new( prfkeys )
			$tst_cp_tool_wdlg.set_html( cphtml )
			$tst_cp_tool_wdlg.set_on_close{
				#abort()
				Sketchup.active_model.abort_operation
				clear_dialog
			}
			$tst_cp_tool_wdlg.add_action_callback("changeFixz"){|d,prm|
				 if prm != ""
					fixz = @fixz
					begin
						@fixz = prm.to_l.to_s
					rescue
						@fixz = fixz
					end
				else
					@fixz = ""
				end
			}
			$tst_cp_tool_wdlg.add_action_callback("changeRot"){|d,prm|
				 if prm != ""
					rot = @rot
					begin
						@rot = prm.to_f
					rescue
						@rot = rot
					end
				 end
			}
			$tst_cp_tool_wdlg.add_action_callback("changeVJST"){|d,prm|
				@alignZ = "MID"
				@alignZ = "MAX" if prm == "TOP"
				@alignZ = "MIN" if prm == "BOTTOM"
				calc_dxyz()
			}
			$tst_cp_tool_wdlg.add_action_callback("changeJST"){|d,prm|
				if prm == "1" or prm == "4" or prm == "7"
					@alignX = "MIN"
				elsif prm == "3" or prm == "6" or prm == "9"
					@alignX = "MAX"
				else
					@alignX = "MID"
				end

				if prm == "1" or prm == "2" or prm == "3"
					@alignY = "MIN"
				elsif prm == "7" or prm == "8" or prm == "9"
					@alignY = "MAX"
				else
					@alignY = "MID"
				end
				@alignX = "" if prm == "0"
				calc_dxyz()
			}
			$tst_cp_tool_wdlg.add_action_callback("changeCompname"){|d,prm|
				#$tst_cp_tool_wdlg.get_element_value("")
				Sketchup.active_model.entities.erase_entities( @instance ) if @instance and @instance.valid?
				#@dfname = prm if prm != ""
				dfname = $tst_cp_tool_wdlg.get_element_value("CPDFLIST")
					splt = dfname.split("||")
					dfindx = splt[0]
					if dfindx != ""
						@dfilename = @complist[dfindx.to_i]
					else
						@dfilename = ""
					end
				#if @dfname
					@dfname = splt[1].to_s
					p @dfname
					@dfname.gsub!(/\&quot\;/,'"')
					@dfname.gsub!(/\&\#39\;/,"'")
				#end
				#	df = Sketchup.active_model.definitions[@dfname]
				#end
				reset(nil)# if df
			}
			$tst_cp_tool_wdlg.add_action_callback("changeCPDIR"){|d,prm|
				Sketchup.active_model.entities.erase_entities( @instance ) if @instance and @instance.valid?
				seldir = $tst_cp_tool_wdlg.get_element_value("CP_DIR_SEL")
				if seldir
					seldir.gsub!(/\&quot\;/,'"')
					seldir.gsub!(/\&\#39\;/,"'")
					if seldir == "SELECT FOLDER"
						seldir = select_component_dir()
					end
					init_webdialog(seldir)
				end
				reset(nil)
			}
			$tst_cp_tool_wdlg.add_action_callback("file_select"){|d,prm|
				if prm != ""
					dfolder = File.dirname( prm )
					if File.exists?( dfolder )
						Sketchup.write_default("ComponentsPlacer","CompsDir1",dfolder.unpack("H*"))
						init_webdialog(dfolder)
					end
				end
			}
			if RUBY_PLATFORM[/darwin/]
				$tst_cp_tool_wdlg.show_modal { init_webdialog }
			else
				$tst_cp_tool_wdlg.show { init_webdialog }
			end
		end
=begin
		def select_component_dir()
			#if RUBY_PLATFORM[/darwin/]
			#	fileselect_32
			#else
				dfolder = UI.openpanel("Select Folder(.Skp file)", "", "*.Skp")###
				return unless dfolder
				dfolder = File.dirname( dfolder )
				if not File.exists?( dfolder ) and $kconvloaded == true
					dfolder2 = nkfconv(dfolder)
				else
					dfolder2 = dfolder
				end
				if File.exists?( dfolder2 )
					Sketchup.write_default("ComponentsPlacer","CompsDir1",dfolder.unpack("H*"))
					return dfolder
				end
			#end
		end
=end
		def get_skp_dir()
			dfolder_arr = Sketchup.read_default("ComponentsPlacer","CompsDir1",[])
			return "" if dfolder_arr == []
			begin
				dfolder2 = dfolder_arr.pack("H*")
			rescue
				dfolder2 = ""
			end
			#if not File.exists?( dfolder2 ) and $kconvloaded == true
			#	@dfolder = nkfconv(dfolder2)
			#else
			@dfolder = dfolder2
			#end
		end

		def skplist_from_dir(  )
			get_skp_dir()
			#dfolder = Sketchup.read_default("ComponentsPlacer","CompsDir1","")
			#return if dfolder == ""
			#@dfolder = dfolder.pack("U*")
			dflist = []
			pdir = File.expand_path( File.join( @dfolder , "*.skp" ) )
			i = 0
			@complist = []
			if File.exists?( @dfolder )
				Dir::glob( pdir ).each {|f|
					#f2 = f.unpack("H*").pack("H*")
					#p f2
					#if not File.exists?(f)
					#	f2 = eval(f)
					#else
					#	f2 = f
					#end
					@complist.push File.basename(f)
					dflist.push "#{i}||" + File.basename(f)
					i += 1
				}
			end
			return dflist
		end

		def init_webdialog(cpdir="")
        	model = Sketchup.active_model
        	defs = model.definitions
			if cpdir == "HOME" or cpdir == ""
				cpdir = "HOME"
				@dlist = []
				defs.each{|df|
					#if df.name.index("//")
					if df.name != "ComponentPlacer_Reference_Bounds"
					if df.hidden? == false and df.group? == false
						@dlist.push "||" + df.name
					end
					end
				}
			else
				@dhash = Hash.new
				@dlist = skplist_from_dir
			end
			@dfname = @dlist[0] if @dfname == ""
			if @dlist.size != 0
				addliststr = []
				addliststr.push "var str ='"
				addliststr.push '<select name="CPDFLIST" id="CPDFLIST" size="8" style="width:300px;"'
				addliststr.push 'onChange ="onChangeCPDFLIST(this[this.selectedIndex].value);">'
				@dlist.each{|pfval|
					pfval.gsub!(/\"/,"&quot;")
					pfval.gsub!(/\'/,"&#39;")
					cmd = '<option '
					#if @dfname == pfval
					#	cmd = cmd + 'selected="selected" '
					#end
					cmd = cmd + 'value="' + pfval + '">' + pfval + '</option>'
					addliststr.push cmd
					#'<option value="' + pfval + '">' + pfval + '</option>'
				}
				addliststr.push '</select>'
				addliststr.push "';"
				addliststr.push 'document.getElementById("CP_DFLIST_DIV").innerHTML = str;'
				jcmd = addliststr.join("")
				$tst_cp_tool_wdlg.execute_script(jcmd)
			end
			#CP_DIR_DIV
			get_skp_dir()
			#dfolder = Sketchup.read_default("ComponentsPlacer","CompsDir1","")
			#if dfolder != ""
			#	@dfolder = dfolder.pack("U*")
			#else
			#	@dfolder = ""
			#end
			addliststr = []
			addliststr.push "var str ='"
			addliststr.push '<select name="CP_DIR_SEL" id="CP_DIR_SEL" size="1" style="width:300px;"'
			addliststr.push 'onChange ="onChangeCPDIR(this[this.selectedIndex].value);">'
			if cpdir == "" or cpdir == "HOME" 
				addliststr.push '<option selected="selected" value="HOME">HOME</option>'
				addliststr.push '<option value="' + @dfolder.gsub(/\\/,'/')  + '">' + @dfolder.gsub(/\\/,'/')  + '</option>' if @dfolder
				@dfolder = "HOME"
			else
				addliststr.push '<option value="HOME">HOME</option>'
				cpdir.gsub!(/\"/,"&quot;")
				cpdir.gsub!(/\'/,"&#39;")
				addliststr.push '<option selected="selected" value="' + cpdir + '">' + cpdir + '</option>'
			end
			#addliststr.push '<option value="SELECT FOLDER">SELECT FOLDER</option>'
			addliststr.push '</select>'
			addliststr.push "';"
			addliststr.push 'document.getElementById("CP_DIR_DIV").innerHTML = str;'
			jcmd = addliststr.join("")
			$tst_cp_tool_wdlg.execute_script(jcmd)
			create_instance()
		end
def get_htmlcode()
htmlcode = '<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<title>COMPONENTS PLACER</title>
		<script type="text/javascript">
			function onChangeFixz(v){
				window.location = "skp:changeFixz@" + v;
			}

			function onChangeRot(v){
				window.location = "skp:changeRot@" + v;
			}
			function onChangeJST(v){
				window.location = "skp:changeJST@" + v;
			}
			function onChangeVJST(v){
				window.location = "skp:changeVJST@" + v;
			}
			function onChangeCPDIR(v){
				window.location = "skp:changeCPDIR@" + v;
			}
			function onChangeCPDFLIST(v){
				window.location = "skp:changeCompname@" + v;
			}
			function OpenFile(v) {
				if(v != ""){
					window.location= "skp:file_select@" + v;
				}
			}
		</script>
		<style type="text/css">
			/*demo page css*/
			body{ font: 100% "Trebuchet MS", sans-serif; margin: 1px;}
			.demoHeaders { margin-top: 2em; }
			ul#icons {margin: 0; padding: 0;}
			ul#icons li {margin: 2px; position: relative; padding: 4px 0; cursor: pointer; float: left;  list-style: none;}
			ul#icons span.ui-icon {float: left; margin: 0 4px;}
			.cssButton{
				color: #ffffff;
				border-top:3px double #9cf;
				border-left:3px double #9cf;
				border-right:3px double #dfd9c3;
				border-bottom:3px double #dfd9c3;
				background: #459e00 url(../img/bg.gif) left bottom repeat-x;
				text-align: center;
				width: 150px;
				font-size: 12px;
			}
			.cssButton:hover{
				color: #fff;
				border-top:3px double #254A70;
				border-left:3px double #254A70;
				border-right:3px double #508AC5;
				border-bottom:3px double #508AC5;
				background: #369;
				width: 150px;
				font-size: 12px;
			}
			.textbox{
				color: #ffffff;
				background: #222222;
				font-size: 12px;
			}
			#tabs {
				font-size: 10px;
			}
			#tabs .ui-tabs-panel {
				height: 150px;
			}
			.atable {
			   table-layout: fixed;
			   border: 1px;
			   width:  360px;
			}
		</style>
	</head>
	<body>
	<form>
	<table border = 0 width=310><tbody>
		<tr><td colspan="2" >
			<div id ="CP_DIR_DIV" > </div>
		</td></tr>
		<tr><td colspan="2" >
		<INPUT TYPE="file" NAME="fopen" OnChange="OpenFile(this.value)">
		</td></tr>
		<tr><td colspan="2" >
			<div id ="CP_DFLIST_DIV" > </div>
		</td></tr>
		<tr><td style="vertical-align: top;">
			<input name="FIXZ" value="FIX Z PICKED" type="BUTTON" class="cssButton"/ >
		</td><td style="vertical-align: top; text-align: left;">
			<input name="CP_FIXZ" id="CP_FIXZ" value="" style="width:70%" type="text" class ="textbox"
			onmouseover="this.focus()" onfocus="this.select()" onChange="onChangeFixz(this.value)"/ >
		</td></tr>
		<tr><td style="vertical-align: top;">
			<input name="V_ALIGN" value="V_ALIGN" type="BUTTON" class="cssButton"/ >
		</td><td style="vertical-align: top; text-align: left;">
			<select name="VJST" id="VJST" size="3" style="width:100px;" onChange ="onChangeVJST(this[this.selectedIndex].value);">
			<option value="TOP">TOP</option>
			<option value="MIDDLE">MIDDLE</option>
			<option selected="selected" value="BOTTOM">BOTTOM</option>
			</select>
		</td></tr>
		<tr><td style="vertical-align: top;">
				<input name="H_ALIGN" value="H_ALIGN" type="BUTTON" class="cssButton"/ >
			</td><td style="vertical-align: top; text-align: left;">
				<input type="radio" name="jst" value="7" id="jst7" onclick="onChangeJST(7);" />
				<input type="radio" name="jst" value="8" id="jst8" onclick="onChangeJST(8);" />
				<input type="radio" name="jst" value="9" id="jst9" onclick="onChangeJST(9);" /><br>
				<input type="radio" name="jst" value="4" id="jst4" onclick="onChangeJST(4);" />
				<input type="radio" name="jst" value="5" id="jst5" onclick="onChangeJST(5);" />
				<input type="radio" name="jst" value="6" id="jst6" onclick="onChangeJST(6);" /><br>
				<input type="radio" name="jst" value="1" id="jst1" onclick="onChangeJST(1);" />
				<input type="radio" name="jst" value="2" id="jst2" onclick="onChangeJST(2);" />
				<input type="radio" name="jst" value="3" id="jst3" onclick="onChangeJST(3);" /><br>
				<input type="radio" name="jst" value="0" id="jst0" onclick="onChangeJST(0);" checked="checked"/>:ORIGIN
		</td></tr>
		<tr><td style="vertical-align: top;">
				<input name="ROTATE" value="ROTATE" type="BUTTON" class="cssButton"/ >
		</td><td style="vertical-align: top; text-align: left;">
				<input name="CP_ROTATE" id="CP_ROTATE" value="0" style="width:70%" type="text" class ="textbox"
				onmouseover="this.focus()" onfocus="this.select()" onChange="onChangeRot(this.value)"/ >
		</td></tr>
		<tr><td style="vertical-align: top;">
				<input name="TAG1" value="TAG1" type="BUTTON" class="cssButton"/ >
		</td><td style="vertical-align: top; text-align: left;">
				<input name="CP_TAG1" id="CP_TAG1" value="" style="width:70%" type="text" class ="textbox"
				onmouseover="this.focus()" onfocus="this.select()" / >
		</td></tr>
		<tr><td style="vertical-align: top;">
				<input name="TAG2" value="TAG2" type="BUTTON" class="cssButton"/ >
		</td><td style="vertical-align: top; text-align: left;">
				<input name="CP_TAG2" id="CP_TAG2" value="" style="width:70%" type="text" class ="textbox"
				onmouseover="this.focus()" onfocus="this.select()" / >
		</td></tr>
		<tr><td style="vertical-align: top;">
				<input name="TAG3" value="TAG3" type="BUTTON" class="cssButton"/ >
		</td><td style="vertical-align: top; text-align: left;">
				<input name="CP_TAG3" id="CP_TAG3" value="" style="width:70%" type="text" class ="textbox"
				onmouseover="this.focus()" onfocus="this.select()" / >
		</td></tr>

	</tbody></table>
	</form>
	</body>
</html>
'
return htmlcode
end
		def langconv( txt )
			return txt
		end

		def create_cp_bounds_all()
			model = Sketchup.active_model
			ents = model.active_entities
			clear_bb_grp
			#ents.erase_entities( @bb_grp ) if @bb_grp and @bb_grp.valid?
			#@bb_grp == nil
			
			lines = []
			@bb_pts = []
			if Sketchup.version.to_f >= 7.0
				model.start_operation "Draw Bounding LINES",true,true,false
			else
				model.start_operation "Draw Bounding LINES"
			end
			#model.commit_operation if Sketchup.version.to_f >= 7.0
			ents.find_all{|e| e.kind_of? Sketchup::ComponentInstance }.each{|ci|
				#tr = ci.transformation
				#bbs = ci.definition.bounds
				#lines.concat bounds_lines_pts( bbs , tr)
				if ci.definition.hidden? == false and ci.definition.name != "ComponentPlacer_Reference_Bounds"
					create_cp_bounds( ci )
				end
			}
			model.commit_operation# if Sketchup.version.to_f >= 7.0
		end
		
		def create_cp_bounds( ci , tempo = false)
			model = Sketchup.active_model
			ents = model.active_entities
			if ci.kind_of? Sketchup::ComponentInstance
			else
				return
			end
			tr = ci.transformation
			bbs = ci.definition.bounds
			lines , pts = bounds_lines_pts( bbs , tr)
			if tempo == false
				@bb_pts = [] if not @bb_pts
				@bb_pts.concat pts

				add_bb_grp()
				
				lines.each{|pt1,pt2| @bb_grp_ents.add_line( pt1 , pt2 ) }
			else
				@tbb_pts = pts
				@tbb_lines = lines
			end
		end
		
		def clear_bb_grp()
			dfs = Sketchup.active_model.definitions
			df = dfs["ComponentPlacer_Reference_Bounds"]

			if df
				df.instances.each{|cpi|
					cpi.erase!
					#cpi.parent.entities.erase_entities [ cpi ]
				}
				kilents = df.entities.map{|e| e }
				df.entities.erase_entities( kilents ) if kilents != []
			end
		end

		def add_bb_grp()
			if not @bb_grp_ents
				dfs = Sketchup.active_model.definitions
				df = dfs["ComponentPlacer_Reference_Bounds"]
				if not df
					df = dfs.add("ComponentPlacer_Reference_Bounds")
				end
				@bb_grp_ents = df.entities
				if not @bb_grp or @bb_grp.valid? == false
					@bb_grp = Sketchup.active_model.active_entities.add_instance( df , Geom::Transformation.new )
				elsif @bb_grp.hidden?
					@bb_grp.hidden = false
				end
				#@bb_grp.name = "ComponentPlacer_Reference_Bounds"
			end
		end
		def bounds_lines_pts( bbs , tr)
			bbsmin = bbs.min.transform( tr )
			bbsmax = bbs.max.transform( tr )
			pts = []
			8.times{|i| pts[i] = bbsmin.clone }
			pts[1].x = pts[2].x = bbsmax.x
			pts[2].y = pts[3].y = bbsmax.y
			pts[4].z = pts[5].z = pts[6].z = pts[7].z = bbsmax.z
			pts[5].x = pts[6].x = bbsmax.x
			pts[6].y = pts[7].y = bbsmax.y
			idslist = [[0,1],[1,2],[2,3],[3,0],[4,5],[5,6],[6,7],[7,4],[0,4],[1,5],[2,6],[3,7]]
			lines = idslist.map{|a,b| [ pts[a] , pts[b] ] }
			return lines , pts
		end
    end # class 
end#module

if not file_loaded?( "Components_Placer.rb" )
	cp_submenu = UI.menu("Plugins").add_submenu("Components Placer")
	cp_submenu.add_item("Start Tool"){ Sketchup.active_model.select_tool TSTComponentPlacer::CompPlacer.new }
	cp_submenu.add_item("Clear Dialog"){ Sketchup.active_model.select_tool TSTComponentPlacer::CompPlacer.clear_dialog }
end

file_loaded("Components_Placer.rb")
